import java.awt.*;
import java.awt.event.*;

import OpticsObjPanel;
import CircularMirrorObject;

class CircularMirrorPanel extends OpticsObjPanel
{
  TextField tfLength;
  TextField tfRadius;

  CircularMirrorPanel()
  {
    super ();

    Panel myPanel = GetMyPanel ();

    tfLength = CreateLabelTextFieldPanel ("Length:",myPanel);
    tfRadius = CreateLabelTextFieldPanel ("Radius:",myPanel);
  }

  public void SetLength (double length)
  {
    tfLength.setText (""+length);
  }

  public void SetRadius (double length)
  {
    tfRadius.setText (""+length);
  }

  public void textValueChanged(TextEvent e)
  {
    Object source = e.getSource ();

    if (source == tfLength && theObject != null)
      {
	Double length = 
	  GetValue (tfLength,-CircularMirrorObject.MAX_LENGTH,
		    CircularMirrorObject.MAX_LENGTH);
	
	if (length != null)
	  ((CircularMirrorObject) theObject).SetLength (length.doubleValue (),
							false);
      }
    if (source == tfRadius && theObject != null)
      {
	Double radius = 
	  GetValue (tfRadius,-1000.0,1000.0);
	
	if (radius != null)
	  ((CircularMirrorObject) theObject).SetRadius (radius.doubleValue (),
							false);
      }
    super.textValueChanged (e);
  }
}
