import java.awt.*;
import java.awt.event.*;

import GlassPanel;
import GeneralLensObject;

class GeneralLensPanel extends GlassPanel
{
  TextField tfLength;
  TextField tfWidth;
  TextField tfRadius[] = new TextField[2];

  GeneralLensPanel()
  {
    super ();

    Panel myPanel = GetMyPanel ();

    tfLength = CreateLabelTextFieldPanel ("Length:",myPanel);
    tfWidth = CreateLabelTextFieldPanel ("Width:",myPanel);
    for (int i = 0; i < 2; i++)
      tfRadius[i] = CreateLabelTextFieldPanel ("Radius "+(i+1)+":",myPanel);
  }

  public void SetLength (double length)
  {
    tfLength.setText (""+length);
  }

  public void SetWidth (double width)
  {
    tfWidth.setText (""+width);
  }

  public void SetRadius (double radius,int no)
  {
    tfRadius[no].setText (""+radius);
  }

  public void textValueChanged(TextEvent e)
  {
    Object source = e.getSource ();

    if (source == tfLength && theObject != null)
      {
	Double length = 
	  GetValue (tfLength,0,
		    GeneralLensObject.MAX_LENGTH);
	
	if (length != null)
	  ((GeneralLensObject) theObject).SetLength (length.doubleValue (),
							false);
      }
    if (source == tfWidth && theObject != null)
      {      
	Double radius = 
	  GetValue (tfWidth,0.0,GeneralLensObject.MAX_WIDTH);
	
	if (radius != null)
	  ((GeneralLensObject) theObject).SetWidth (radius.doubleValue (),
						    false);
      }
    for (int i = 0; i < 2; i++)
      if (source == tfRadius[i] && theObject != null)
	{
	  Double radius = 
	    GetValue (tfRadius[i],-1000.0,1000.0);
	  
	  if (radius != null)
	    ((GeneralLensObject) theObject).SetRadius (radius.doubleValue (),i,
						       false);
	}
    super.textValueChanged (e);
  }
}

