import java.awt.*;
import java.awt.event.*;

import OpticsObjPanel;
import GlassObject;

class GlassPanel extends OpticsObjPanel
{
  TextField tfRefractionIndex[] = new TextField[2];
  Choice chMaterial;

  GlassPanel()
    {
      super ();
      
      Panel myPanel = GetMyPanel ();
      
      chMaterial = CreateChoicePanel (myPanel);
      chMaterial.add ("-");
      chMaterial.add ("Crown glass");
      chMaterial.add ("Dense flint glass");
      chMaterial.add ("Light flint glass");
      chMaterial.add ("Crystal quartz");
      chMaterial.add ("Borosilicate crown glass");
      chMaterial.add ("Acrylic plastic");
      chMaterial.add ("Vitreous quartz");
      tfRefractionIndex[0] = CreateLabelTextFieldPanel ("n (400 nm):",myPanel);
      tfRefractionIndex[1] = CreateLabelTextFieldPanel ("n (600 nm):",myPanel);
    }
  
  public void SetRefractionIndex (double index[])
    {
      tfRefractionIndex[0].setText (""+index[0]);
      tfRefractionIndex[1].setText (""+index[1]);
    }
  
  public void SetMaterial (int matr)
    {
      chMaterial.select (matr+1);
    }

  public void textValueChanged(TextEvent e)
  {
    Object source = e.getSource ();

    if ((source == tfRefractionIndex[0] || source == tfRefractionIndex[1]) && theObject != null)
      {
	Double index0 = 
	  GetValue (tfRefractionIndex[0],1.0,10.0);
	Double index1 = 
	  GetValue (tfRefractionIndex[1],1.0,10.0);
	
	if (index0 != null && index1 != null)
	  {
	    double vals[] = { index0.doubleValue (), index1.doubleValue () };
	    ((GlassObject) theObject).SetRefractionIndex (vals,false);
	    ((GlassObject) theObject).SetMaterial (-1,false);
	    chMaterial.select (0);
	  }
      }
    super.textValueChanged (e);
  }

  public void itemStateChanged (ItemEvent e)
    {
      Object source = e.getSource ();
      
      if (source == chMaterial)
	{
	  int index = chMaterial.getSelectedIndex ();

	  ((GlassObject) theObject).SetMaterial (index-1,false);
	}
    }
}
