import java.awt.*;
import java.lang.Math;
import java.util.*;
import OpticsObject;
import OpticsObjPanel;
import LightRay;

abstract class LightSourceObject extends OpticsObject
{
  boolean bMonochrome = false;
  float fWaveLength = 600;
  int nRays = 5;
  int nColorRays = 15;

  LightSourceObject ()
  {
    nLabRadius = 20;
  }

  public void SetPanel (OpticsObjPanel panel)
  {
    super.SetPanel (panel);
    if (thePanel != null)
      {
	((LightSourcePanel) thePanel).SetWaveLength (fWaveLength);
	((LightSourcePanel) thePanel).SetRays (nRays);
	((LightSourcePanel) thePanel).SetColorRays (nColorRays);	
	((LightSourcePanel) thePanel).SetMonochrome (bMonochrome);	
      }
  }
  
  public void SetWaveLength (float waveLength,boolean setPanel)
  {
    theLabCanvas.AbortCalculation ();
    fWaveLength = waveLength;
    if (setPanel && thePanel != null)
      ((LightSourcePanel) thePanel).SetWaveLength (fWaveLength);
    theLabCanvas.repaint ();
    theLabCanvas.Recalculate ();
  }

  public void SetRays (int rays,boolean setPanel)
  {
    theLabCanvas.AbortCalculation ();
    nRays = rays;
    if (setPanel && thePanel != null)
      ((LightSourcePanel) thePanel).SetRays (nRays);
    theLabCanvas.repaint ();
    theLabCanvas.Recalculate ();
  }

  public void SetColorRays (int rays,boolean setPanel)
  {
    theLabCanvas.AbortCalculation ();
    nColorRays = rays;
    if (setPanel && thePanel != null)
      ((LightSourcePanel) thePanel).SetColorRays (nRays);
    theLabCanvas.repaint ();
    theLabCanvas.Recalculate ();
  }

  public void SetMonochrome (boolean mono,boolean setPanel)
  {
    theLabCanvas.AbortCalculation ();
    bMonochrome = mono;
    if (setPanel && thePanel != null)
      ((LightSourcePanel) thePanel).SetMonochrome (bMonochrome);
    theLabCanvas.repaint ();
    theLabCanvas.Recalculate ();
  }

  /*
  public void DrawContours (Graphics g,boolean selected)
  {
    g = InitDrawContours (g,selected);

    g.drawArc (-20,-20,
	       40,40,
	       RadiansToIntDegrees(fDirection+fWidth),
	       360-RadiansToIntDegrees(2*fWidth));
    g.drawOval (-10,-10,
	       20,20);
    g.drawLine (-3,-3,3,3);
    g.drawLine (3,-3,-3,3);
  }
  */
  /*
  public void HandlePointMove (int nPoint,Point pt)
  {
    super.HandlePointMove (nPoint,pt);

    if (nPoint == 1)
      {
	double fDirection = GetPointDirection (pt);

	SetDirection (fDirection,true);
      }
    if (nPoint == 2)
      {
	double fWidth = GetPointAngle (pt);

	fWidth = Math.abs (fWidth);

	SetWidth (fWidth,true);
      }
  }
  */
  /*
  public void GetRays (Vector raysToTrace)
  { 
    for (int i = 0; i < nRays; i++)
      {
	double fAngle = fDirection + (nRays > 1 ? 
				      2*fWidth * i / (nRays-1) -fWidth :
				      0 );
	raysToTrace.addElement (new LightRay (fX,fY,
					      Math.cos (fAngle),
					      -Math.sin (fAngle)));
      }
  }
  */
  public boolean IsSource ()
  {
    return true;
  }
  /*
  public Vector GetHandlePoints ()
  {
    Vector v = super.GetHandlePoints ();
    
    v.addElement (new Point ((int) (( 10.0*Math.cos (fDirection))),
			     (int) ((-10.0*Math.sin (fDirection)))));
    v.addElement (new Point ((int) (( 20.0*Math.cos (fDirection+fWidth))),
			     (int) ((-20.0*Math.sin (fDirection+fWidth)))));
    return v;
  }
  */
}
