import java.awt.*;
import java.awt.event.*;
import java.lang.Math;

import OpticsObjPanel;
import LightSourceObject;

class LightSourcePanel extends OpticsObjPanel
{
  TextField tfRays;  
  TextField tfWaveLength;  
  TextField tfColorRays;
  Checkbox cbMonochrome;

  Panel panelMonoCol;
  CardLayout clMonoCol;

  LightSourcePanel()
  {
    super ();

    Panel myPanel = GetMyPanel ();

    cbMonochrome = CreateCheckboxPanel ("Monochrome",myPanel);
    panelMonoCol = new Panel (clMonoCol = new CardLayout ());
    myPanel.add (panelMonoCol);
    tfColorRays = CreateLabelTextFieldPanelWithName ("Color rays:",
						     panelMonoCol,
						     ""+((boolean) false));
    tfWaveLength = CreateLabelTextFieldPanelWithName ("WaveLength:",
						      panelMonoCol,
						      ""+((boolean) true));
    tfRays = CreateLabelTextFieldPanel ("Rays:",myPanel);
  }

  public void SetRays (int rays)
  {
    tfRays.setText (""+rays);
  }

  public void SetColorRays (int rays)
  {
    tfColorRays.setText (""+rays);
  }

  public void SetWaveLength (float waveLength)
  {
    tfWaveLength.setText (""+waveLength);
  }

  public void SetMonochrome (boolean mono)
  {
    cbMonochrome.setState (mono);
    ShowMonoOrCol ();
  }

  public void ShowMonoOrCol ()
  {
    clMonoCol.show (panelMonoCol,""+cbMonochrome.getState ());
  }

  public void textValueChanged(TextEvent e)
  {
    Object source = e.getSource ();

    if (source == tfRays && theObject != null)
      {
	Integer rays = GetValue (tfRays,1,500);

	if (rays != null)
	  ((LightSourceObject) theObject).SetRays (rays.intValue (),
						   false);
      }
    if (source == tfColorRays && theObject != null)
      {
	Integer rays = GetValue (tfColorRays,1,500);

	if (rays != null)
	  ((LightSourceObject) theObject).SetColorRays (rays.intValue (),
							false);
      }
    if (source == tfWaveLength && theObject != null)
      {
	  Double waveLength = GetValue (tfWaveLength,
				       LightRay.MIN_WAVE_LENGTH,
				       LightRay.MAX_WAVE_LENGTH);
	  
	  if (waveLength != null)
	      ((LightSourceObject) theObject).
		  SetWaveLength ((float) waveLength.doubleValue (),
				 false);
      }
    super.textValueChanged (e);
  }

  public void itemStateChanged(ItemEvent e)
  {
    Object source = e.getSource ();
    
    if (source == cbMonochrome)
      {
	ShowMonoOrCol ();
	((LightSourceObject) theObject).
	  SetMonochrome (cbMonochrome.getState (),false);
      }
    super.itemStateChanged (e);
  }
}
