import java.awt.*;
import java.awt.event.*;
import java.lang.*;

class OpticsObjPanel extends Panel implements TextListener, ItemListener
{
  TextField tfXPos;
  TextField tfYPos;
  TextField tfDirection;

  public OpticsObject theObject;

  Panel mainPanel;
  
  OpticsObjPanel()
  {
    super(new BorderLayout ());

    mainPanel = this;

    Panel myPanel = new Panel (new GridLayout (0,1));

    mainPanel.add("North",myPanel);

    tfXPos = CreateLabelTextFieldPanel ("X pos:",myPanel);
    tfYPos = CreateLabelTextFieldPanel ("Y pos:",myPanel);
    tfDirection = CreateLabelTextFieldPanel ("Direction:",myPanel);
  }

  protected Panel GetMyPanel ()
  {
    Panel myPanel = new Panel (new GridLayout (0,1));
    Panel newPanel = new Panel (new BorderLayout ());
    
    mainPanel.add("Center",newPanel);
    mainPanel = newPanel;
    mainPanel.add("North",myPanel);
    return myPanel;
  }

  protected TextField CreateLabelTextFieldPanel (String label,Panel addPanel)
  {
    Panel panel = new Panel (new BorderLayout ());

    TextField tf;

    panel.add ("West",new Label (label));
    panel.add ("Center",tf = new TextField (5));

    addPanel.add (panel);

    tf.addTextListener (this);
    
    return tf;
  }

  protected TextField CreateLabelTextFieldPanelWithName (String label,Panel addPanel,String name)
  {
    Panel panel = new Panel (new BorderLayout ());

    TextField tf;

    panel.add ("West",new Label (label));
    panel.add ("Center",tf = new TextField (5));

    addPanel.add (name,panel);

    tf.addTextListener (this);
    
    return tf;
  }

  protected Checkbox CreateCheckboxPanel (String label,Panel addPanel)
  {
    Panel panel = new Panel (new BorderLayout ());

    Checkbox cb;

    panel.add ("Center",cb = new Checkbox (label));

    addPanel.add (panel);

    cb.addItemListener (this);
    
    return cb;
  }

  protected Choice CreateChoicePanel (Panel addPanel)
  {
    Panel panel = new Panel (new BorderLayout ());

    Choice ch;

    panel.add ("Center",ch = new Choice ());

    addPanel.add (panel);

    ch.addItemListener (this);
    
    return ch;
  }

  public void SetLocation (double fX,double fY)
  {
    tfXPos.setText (""+fX);
    tfYPos.setText (""+fY);
  }

  public void SetDirection (double fDirection)
  {
    tfDirection.setText (""+fDirection*180/Math.PI);
  }

  public Double GetValue (TextField tf,double min,double max)
  {
    try
      {
	Double d = new Double (tf.getText ().trim ());
	if (d.doubleValue () >= min && d.doubleValue () <= max)
	  return d;
      }
    catch ( Exception ex )
      {

      }
    return null;
  }

  public Integer GetValue (TextField tf,int min,int max)
  {
    try
      {
	Integer i = new Integer (tf.getText ().trim ());
	if (i.intValue () >= min && i.intValue () <= max)
	  return i;
      }
    catch ( Exception ex )
      {

      }
    return null;
  }

  public void textValueChanged(TextEvent e)
  {
    Object source = e.getSource ();

    if ((source == tfXPos || source == tfYPos) && theObject != null)
      {
	Double x = GetValue (tfXPos,-1000.0,1000.0);
	Double y = GetValue (tfYPos,-1000.0,1000.0);

	if (x != null && y != null)
	  theObject.SetLocation (x.doubleValue (),y.doubleValue (),
				 false);
      }
    if (source == tfDirection && theObject != null)
      {
	Double dir = GetValue (tfDirection,-360.0,360.0);

	if (dir != null)
	  theObject.SetDirection (dir.doubleValue ()/180.0*Math.PI,
				  false);
      }
  }

  public void itemStateChanged(ItemEvent e)
  {

  }
}
