import java.awt.*;

import PaperObject;
import LightRay;

class PaperDisplay extends Canvas
{
  PaperObject theObject;

  PaperDisplay ()
  {
    setBackground (Color.black);
  }

  public void paint (Graphics g)
  {
    int w = getSize ().width;
    int h = getSize ().height;
    
    g.setColor (Color.lightGray);
    g.draw3DRect (0,0,w-1,h-1,false);

    if (theObject != null && theObject.vectorRaysCaught != null)
      for (int i = theObject.vectorRaysCaught.size () / 2 - 1; i >= 0; i--)
	{
	  LightRay ray = (LightRay) theObject.vectorRaysCaught.elementAt (i*2);
	  double s = 
	    ((Double) theObject.vectorRaysCaught.elementAt (i*2+1)).doubleValue ();
	  
	  g.setColor (ray.GetColor ());
	  g.drawLine (1,1+(int) ((h-2)*s),w-2,1+(int) ((h-2)*s));
	}
  }

/*
    for (int y = 1; y < h-1; y ++)
      {
	g.setColor (GetColor ((float) y/(h-1)));
	g.drawLine (1,y,w-2,y);
      }

  double InterP (double vals[][],double fFrac)
    {
      int i = 0;
      
      for (; vals[i][0] < fFrac; i++);

      if (i == 0)
	return vals[0][1];
      return vals[i-1][1]+((fFrac-vals[i-1][0])*(vals[i][1]-vals[i-1][1])/(vals[i][0]-vals[i-1][0]));
    }
  
  Color GetColor (float fFrac)
    {
      float fIntensity = (float) 1.0;
      
      double redvals[][] = {
	{0,255},{345,255},{400,235},{435,215},{475,155},{500,105},
	{515,30},{530,0},{985,0},{990,30},{1015,90},{1050,130},{1120,185}};
      double greenvals[][] = {
	{0,0},{25,0},{35,60},{80,120},{130,160},{180,190},{230,215},{315,255},
	{685,255},{750,230},{820,190},{880,155},{930,100},{985,25},
	{990,0},{1185,0},{1190,25},{1100,0},{1120,0}};
      double bluevals[][] = {
	{0,0},{350,0},{410,25},{450,25},{500,0},{515,0},{520,70},{560,170},{600,230},
	{685,255},{990,255},{1045,230},{1120,195}};

      double red = InterP(redvals,fFrac*1120)*fIntensity/255.0;
      double green = InterP(greenvals,fFrac*1120)*fIntensity/255.0;
      double blue = InterP(bluevals,fFrac*1120)*fIntensity/255.0;
      
      //      System.out.println (""+fFrac+"  ("+red+","+green+","+blue+")");

      return new Color ((float) (red),
			(float) (green),
			(float) (blue));
    }	
*/  
}
