import java.awt.*;
import java.awt.event.*;

import OpticsObjPanel;
import PaperDisplay;
import PaperObject;

class PaperPanel extends OpticsObjPanel
{
  TextField tfLength;
  PaperDisplay pdDisplay;

  PaperPanel()
  {
    super ();

    Panel myPanel = GetMyPanel ();

    tfLength = CreateLabelTextFieldPanel ("Length:",myPanel);
    pdDisplay = new PaperDisplay ();
    mainPanel.add("Center",pdDisplay);
  }

  public void SetLength (double length)
  {
    tfLength.setText (""+length);
  }

  public void SetObject (PaperObject obj)
  {
    pdDisplay.theObject = obj;
  }

  public void textValueChanged(TextEvent e)
  {
    Object source = e.getSource ();

    if (source == tfLength && theObject != null)
      {
	Double length = 
	  GetValue (tfLength,0,PaperObject.MAX_LENGTH);
	
	if (length != null)
	  ((PaperObject) theObject).SetLength (length.doubleValue (),
					       false);
      }
    super.textValueChanged (e);
  }
}
